function util_toDecimal(x) {
  var f = parseFloat(x);
  if (isNaN(f)) {
  return;
  }
  f = Math.round(x*100);
  return f;
}

/**
 * 字典数组排序，只针对纯英文、数字或纯中文的排序
 * @param: dictArray 需要排序的字典数组
 * @param: sortKey  需要进行排序的键
 * @param: sortType asc升序(默认)  desc 降序
 **/
function util_dictArraySorting(dictArray,sortKey,sortType="asc"){
    if (sortType == 'asc'){
      dictArray.sort(function (dictA, dictB){
        return escape(dictA[sortKey]).indexOf("%u") < 0? dictA[sortKey] - dictB[sortKey]:dictA[sortKey].localeCompare(dictB[sortKey])
      })
    }
    if (sortType == 'desc'){
      dictArray.sort(function (dictA, dictB){
        return escape(dictA[sortKey]).indexOf("%u") < 0? dictB[sortKey] - dictA[sortKey]:dictB[sortKey].localeCompare(dictA[sortKey])
      })
    }
    return dictArray
}

function domains_process(){
    //$('#message-info').html('加载中...');
    var bg = chrome.extension.getBackgroundPage();
    //
    bg.domains_get_data_process();
    //
    bg.domains_get(function (callback_data) {
        //$('#message-info').html('');
        //
        domains = callback_data['domains'];
        if(typeof domains === 'undefined' ){
            domains = [];
        }
        //
        if(domains.length ==0){
            //$('#message-info').html('');
            $('.batchdig-form').show();
        }else{
            $('.batchdig-form').hide();
        }
        //
        var domains_total = domains.length;
        var domains_hasdig = 0;
        var domains_hasdig_emails = 0;
        for(i=0;i<domains.length;i++){
            if(domains[i]['s'] == 2){
                domains_hasdig +=1;
            }
            var _emails = domains[i]['e'];
            domains_hasdig_emails += _emails.length;
        }
        if(domains_total>0){
            var domains_percentage = util_toDecimal(domains_hasdig/domains_total)+'%';
        }else{
            var domains_percentage = '0.00%';
        }
        //
        if(domains_total>0){
            var batchdig_desc = "正在挖掘<span>"+domains_total+"</span>个域名，已挖掘<span>"+domains_hasdig+"</span>个域名，已挖掘<span>"+domains_hasdig_emails+"</span>个邮箱，进度<span>"+domains_percentage+"</span>";
            $('#batchdig-desc').html(batchdig_desc);
            $('.actions').show();
        }else{
            $('#batchdig-desc').html('');
            $('.actions').hide();
        }

        //
        if(domains.length > 0){
            //
            var batchdig_list_wrapper_html = $('.batchdig-list-wrapper').html();
            if(batchdig_list_wrapper_html.length>0 && domains_hasdig==domains_total && domains_total>100){

            }else{
                //
                $('.batchdig-list-wrapper').html('');
                //
                for(i=0;i<domains.length;i++){
                    var _domain = domains[i];
                    var bl_item_html = "<div class='bl-item'>";
                    bl_item_html += "<div class='bl-item-domain'>"+_domain['d']+"</div>";
                    bl_item_html +="<div class='bl-item-emails'>";
                    var _emails = _domain['e'];
                    for(e=0;e<_emails.length;e++){
                        bl_item_html+="<div className='bl-item-email'>"+_emails[e]+"</div>";
                    }
                    bl_item_html +="</div>";
                    bl_item_html += "</div>";
                    //
                    $('.batchdig-list-wrapper').append(bl_item_html);
                    //
                }
            }
            //
        }else{
             $('.batchdig-list-wrapper').html('');
        }
        //如果长时间未动，就主动触发
        /*if(domains.length > 0 && domains_hasdig < domains_total){
            var last_t = 0;
            for(i=0;i<domains.length;i++){
                if(domains[i]['t'] > last_t){
                    last_t = domains[i]['t'];
                }
            }
            if((last_t+10) < Date.now()){
                for(i=0;i<domains.length;i++){
                    if(domains[i]['s']==0 || (domains[i]['s']==1 && domains[i]['q']==0)){
                        domains[i]['m'] = Date.now();
                        break;
                    }
                }
                for(i=0;i<domains.length;i++){
                    if(domains[i]['s'] == 1){
                        domains[i]['s'] = 0;
                    }
                }
                //
                bg.domains_set(domains);
                //
            }
        }*/
        //
    });
}
domains_process();

setInterval(domains_process, 3000);

$('#test_clean_data_btn').click(function (){
    var bg = chrome.extension.getBackgroundPage();
    //bg.domains_remove();
    bg.domains_clear();
    bg.domains_set_callback([],function (){
        //
        console.log('domain has clean');
        domains_process();
        //
    });
    //
});

$('#test_get_data_btn').click(function (){
    console.log('test_get_data_btn');
     var bg = chrome.extension.getBackgroundPage();
     bg.domains_get_data_process();
     console.log(fff);
});

$('#btn_domains_clean').click(function (){
    if(confirm("确定清空吗？注意清空需要花费些时间") == true){
        var bg = chrome.extension.getBackgroundPage();
        bg.domains_clear();
    }
});
//
$('.batchdig-form form #submit').click(function (){
    var bg = chrome.extension.getBackgroundPage();
    bg.plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date === 'undefined'){
            $('.jihuo').show();
            $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
            $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
            return;
        }else{
            expire_date = expire_date.replace('T00:00:00.000Z','');
            $('#expire_date').html(expire_date);
            if (util_check_expire(expire_date)) {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }
        }
        //
        var form_domains_value = $('#domains').val();
        //
        form_domains_value = form_domains_value.trim();
        //分割
        form_domains_arr = form_domains_value.split(/[(\r\n)\r\n]+/);
        //去重
        if(form_domains_arr.length>1){
            form_domains_arr = Array.from(new Set(form_domains_arr));
        }
        //检测是否含有http,如果未含有提示
        var not_hefa_url = [];
        var new_form_domains_arr = [];
        for(i=0;i<form_domains_arr.length;i++){
            var domain = form_domains_arr[i];
            //两边去空,小写
            domain = domain.trim().toLowerCase();
            //尽量让域名正确
            //https://www.emailcamel.com/ff/d/dd
            var _domain = domain.replace('//','');
            var _pos = _domain.indexOf('/');
            if(_pos!=-1){
                var _domain_yichu = _domain.slice(_pos);
                if(_domain_yichu!='/'){
                    domain = domain.replace(_domain_yichu, '');
                }
            }
            //
            form_domains_arr[i] = domain;
            //
            if(domain && domain.indexOf('http')==-1){
                not_hefa_url.push(domain);
            }else{
                if(domain){
                    new_form_domains_arr.push(domain);
                }
            }
        }
        //
        if(not_hefa_url.length>0){
            var message_info_waring = "<div style='color:red;max-height: 100px;overflow-y: scroll;'><p style='margin-bottom: 5px;'>以下网址缺少http或者https开头,请补充完整!</p>"+not_hefa_url.join('<br />')+"</div>";
            $('#message-info').html(message_info_waring);
        }else{
             //
            new_form_domains_arr = Array.from(new Set(new_form_domains_arr));
            form_domains_arr = new_form_domains_arr;
            if(form_domains_arr.length>0){
                console.log('form_domains_arr');
                console.log(form_domains_arr);
                var bg = chrome.extension.getBackgroundPage();
                //
                var domains = [];
                for(f=0;f<form_domains_arr.length;f++){
                    var domain = {
                        'd':form_domains_arr[f], //域名
                        'e':[], //邮箱列表
                        's':0,  //状态
                        'q':0,  //当前已请求量
                        'tq':0, //总请求量
                        't':0,  //当前请求完成时间戳
                        'm':0,   //长时间未动,popup->background主动更新
                    }
                    domains.push(domain);
                }
                bg.domains_set(domains);
                //
                $('#message-info').html('<div class="alert-info">添加成功</div>');
                $('.batchdig-form').hide();
                $('#domains').val('');
                domains_process();
                //
            }else{
                var message_info_waring = "<div style='color:red;'><p style='margin-bottom: 5px;'>请至少输入1个网址!</p></div>";
                $('#message-info').html(message_info_waring);
            }
        }
        //
    });
});
//

function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function get_expire(){
    // popup ---> content
                      /*  chrome.tabs.query({
                            active: true,
                            currentWindow: true
                        }, (tabs) => {
                            let message = {
                                action: 'set_expire',
                                date: ''
                            }
                            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                                console.log('popup=>content set_expire')
                                console.log(res)
                                expire_data = res[0];
                                expire_date = expire_data['expire'];
                                expire_date = expire_date.replace('T00:00:00.000Z','');
                                $('#expire_date').html(expire_date);
                                //$('.catalog-products-num').html('0');
                                //$('#message-info').html('');
                                //
                                //$('#message-info').html('完成,提取:'+res.length);
                                //$('#message-info').html('完成')
                            })
                        })*/
    var bg = chrome.extension.getBackgroundPage();
    bg.plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date === 'undefined'){
            $('.jihuo').show();
            $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
            $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
            return;
        }else{
            expire_date = expire_date.replace('T00:00:00.000Z','');
            $('#expire_date').html(expire_date);
            if (util_check_expire(expire_date)) {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }
        }
    });
}

get_expire();

function extract_domains_export_clean(){
    $('#btn_domains_export').click(function (){
        //
        $('#message-info').html('<span style="font-size: 12px;">导出需要花费时间，请保持界面不动,处理中...</span>');
        console.log('extract_domains_export_clean');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('extract_domains_export_clean');
            //console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if (typeof expire_date === 'undefined') {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            } else {
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z', '');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }
        });
        bg.domains_get(function (callback_data) {
            //
            domains = callback_data['domains'];
            if (typeof domains === 'undefined') {
                domains = [];
            }
            //
            var export_domains = [];
            //email非空
            for(i=0;i<domains.length;i++){
                var _emails = domains[i]['e'];
                if(_emails.length > 0){
                     for(j=0;j<_emails.length;j++){
                        export_domains.push({
                            'domain': domains[i]['d'],
                            'email': _emails[j],
                        })
                     }
                }
            }
            //email为空
            for(i=0;i<domains.length;i++){
                var _emails = domains[i]['e'];
                if(_emails.length  == 0){
                      export_domains.push({
                          'domain': domains[i]['d'],
                          'email': '',
                      })
                }
            }
             //
            exportToExcel(export_domains, 'gycharm-linkedin-domains-emails-export-'+Date.now(), "Sheet1");
            //
            //
            $('#message-info').html('');
        });
        //
    });
}

extract_domains_export_clean();

//
function jihuo(){
    $('#jihuo_btn').click(function (){
        var jihuo_text = $('#jihuo_text').val();
        jihuo_text = jihuo_text.trim();
        $('#message-account-info').html('');
        if(jihuo_text==''){
            $('#message-account-info').html('<span style="color:red;">请输入激活码</span>');
            return;
        }
        //
        // other then GET
        let options = {
            method: 'GET',
            headers: {
                'Content-Type':'application/json;charset=utf-8'
            },
            //body: JSON.stringify(res)
        }
        // Fake api for making post requests
        let fetchRes = fetch( "https://api.gycharm.com/v1/plugin-chkpro/" + jihuo_text);
        fetchRes.then(res =>
            res.json()).then(d => {
                console.log('post response:');
                console.log(d);
                console.log(d['VAL']);
                //
                if (d['VAL'] === "NO_KEY") {
                    $('#message-account-info').html('<span style="color:red;">激活码不存在!</span>');
                }else if(d['VAL'] == 'HAS_BOUND'){
                    $('#message-account-info').html('<span style="color:red;">激活码已使用过!</span>');
                }else {
                    var expire_date = d['VAL'];
                    if (util_check_expire(expire_date) == false) {
                        var bg = chrome.extension.getBackgroundPage();
                        bg.plugin_set_expire(expire_date,function (){
                            expire_date = expire_date.replace('T00:00:00.000Z','');
                            $('#expire_date').html(expire_date);
                            $('.jihuo').hide();
                            $('#message-account-info').html('');
                            //
                            bg.plugin_set_active_code(jihuo_text);
                            //
                        });
                      //
                    }else{
                        $('.jihuo').show();
                        $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                        return;
                    }
                }
                //
            })
                //
    });
}
jihuo();
//
//get columns
function getColumns(paramData){

	var header = [];
	$.each(paramData[0], function (key, value) {
		//console.log(key + '==' + value);
		var obj = {}
		obj["headertext"] = key;
		obj["datatype"] = "string";
		obj["datafield"] = key;
		header.push(obj);
	});
	return header;
}
//
function linkedin_company_search_staff_query(){
    $('#btn_linkedin-company-search-staff').click(function (){
        let company_page_url = $('#current-company-page-url').val();
        company_page_url = company_page_url.trim().toLowerCase();
        if(company_page_url.indexOf('http')!=-1 || company_page_url.indexOf('www')!=1){
            let domain = company_page_url;
            domain = domain.trim().toLowerCase();
            //尽量让域名正确
            //https://www.emailcamel.com/ff/d/dd
            var _domain = domain.replace('//','');
            var _pos = _domain.indexOf('/');
            if(_pos!=-1){
                var _domain_yichu = _domain.slice(_pos);
                if(_domain_yichu!='/'){
                    domain = domain.replace(_domain_yichu, '');
                }
            }
            company_page_url = domain;
        }
        company_page_url = company_page_url.replaceAll('https:','')
            .replaceAll('http:','')
            .replaceAll('/','')
            .replaceAll('www.','')
        if(company_page_url){
            $('#message-info').html('');
            let google_search_url = 'https://www.google.com/search?q=' + company_page_url + '+site:linkedin.com/in/&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
            //
            var bg = chrome.extension.getBackgroundPage();
            let linkedin_company_search_staff_value = {
                'company_page_url': company_page_url
            };
            bg.linkedin_company_search_staff_value_set(linkedin_company_search_staff_value,function (){
               //
                chrome.tabs.query({ active: true, currentWindow: true }, function(tabs) {
                  // 获取当前激活的标签页
                  let activeTab = tabs[0];
                  // 新的 URL
                  let newUrl = google_search_url;

                  // 使用chrome.tabs.update更新当前标签页的URL
                  chrome.tabs.update(activeTab.id, { url: newUrl });
                });
                //chrome.tabs.create({ url: google_search_url, active: true});
                //
            });
            //
            //
        }else{
            //
            $('#message-info').html("<span style='color:red;'>公司名或者公司网址不能为空！</span>");
            //
        }
    });
}
linkedin_company_search_staff_query();
//
function linkedin_company_search_staff_export(){
    $('#btn_linkedin-company-search-staff-export').click(function (){
        //
        console.log('btn_linkedin-company-search-staff-export');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('btn_linkedin-company-search-staff-export 2');
            console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if(typeof expire_date === 'undefined'){
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }else{
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }
            //
            chrome.tabs.getSelected(null, function (tab) {
                var current_url =  tab.url;
                if(current_url){
                    if(current_url.indexOf('search')==-1){
                        alert('查询后再导出！');
                        return;
                    }
                }
            });
            $('#message-info').html('<span style="font-size: 12px;">导出需要花费时间，请保持界面不动,处理中...</span>');
            // popup ---> content
            chrome.tabs.query({
                        active: true,
                        currentWindow: true
                    }, (tabs) => {
                        let message = {
                            action: 'linkedin_google_people_export',
                            info: ''
                        }
                        chrome.tabs.sendMessage(tabs[0].id, message, res => {
                            console.log('popup=>content linkedin_google_people_export')
                            console.log(res)
                            //
                            //
                            exportToExcel(res['shangjia_infos'], res['file_name'], "Sheet1");
                            //
                            $('#message-info').html('');
                            //
                        })
            })
        });
        //
    });
}
linkedin_company_search_staff_export();
//
function init_company_search_staff(){
    chrome.tabs.getSelected(null, function (tab) {
        var current_url =  tab.url;
        if(current_url){
            if(current_url.indexOf('/company/')!=-1){
                //
                $('#current-company-page-box').show();
                $('#current-company-page-box-warn').hide();
                $('#current-company-page-url').html(current_url);
                //
            }
        }
    });
    //
    var bg = chrome.extension.getBackgroundPage();
    bg.linkedin_company_search_staff_value_get(function (callback_data) {
            console.log('linkedin_company_search_staff_value_get');
            console.log(callback_data);
            if(callback_data['linkedin_company_search_staff_value']){
                 let company_page_url = callback_data['linkedin_company_search_staff_value']['company_page_url'];
                console.log('company_page_url:'+company_page_url);
                if (typeof company_page_url !== 'undefined') {
                    $('#current-company-page-url').val(company_page_url);
                }
            }
    });
    //
}
init_company_search_staff();
//
function linkedin_init(){
    var bg = chrome.extension.getBackgroundPage();
    bg.storage_get(function (callback_data) {
        if(callback_data['pause'] == 1){
            $('#linkedin-pause').text('采集已暂停,可点击开启');
        }else{
            $('#linkedin-pause').text('采集已开启,可点击暂停');
        }
        $('#linkedin-pause').show();
    });
    //

    //
}
linkedin_init();
//
function nav(){
    $('.nav-item').click(function (){
        $('.nav-item').removeClass('active');
        $(this).addClass('active');
        if($(this).attr('id') == 'nav-find-website'){
            $('.nav-kp-email-content').hide();
            $('.nav-find-website-content').show();
            $('.nav-batchdig-emails-content').hide();
            $('.nav-company-search-staff-content').hide();
            $('.nav-people-email-content').hide();
        }
        if($(this).attr('id') == 'nav-batchdig-emails'){
            $('.nav-find-website-content').hide();
            $('.nav-batchdig-emails-content').show();
            $('.nav-kp-email-content').hide();
            $('.nav-company-search-staff-content').hide();
            $('.nav-people-email-content').hide();
        }
        if($(this).attr('id') == 'nav-company-search-staff'){
            $('.nav-kp-email-content').hide();
            $('.nav-find-website-content').hide();
            $('.nav-batchdig-emails-content').hide();
            $('.nav-company-search-staff-content').show();
            $('.nav-people-email-content').hide();
        }
        if($(this).attr('id') == 'nav-people-email'){
            $('.nav-kp-email-content').hide();
            $('.nav-find-website-content').hide();
            $('.nav-batchdig-emails-content').hide();
            $('.nav-company-search-staff-content').hide();
            $('.nav-people-email-content').show();
        }
        if($(this).attr('id') == 'nav-kp-email'){
            $('.nav-kp-email-content').show();
            $('.nav-find-website-content').hide();
            $('.nav-batchdig-emails-content').hide();
            $('.nav-company-search-staff-content').hide();
            $('.nav-people-email-content').hide();
        }
    });
}
nav();

//
function nav_init(){
    //
    console.log('nav_init');
    chrome.tabs.getSelected(null, function (tab) { // 先获取当前页面的tabID
        let current_url = tab.url;
        console.log('nav_init:'+current_url);
        if(current_url){
            if(current_url.indexOf('google')!=-1 && current_url.indexOf('linkedin.com')!=-1){
                $('.nav-item').removeClass('active');
                $('#nav-company-search-staff').addClass('active');
                $('.nav-kp-email-content').hide();
                $('.nav-find-website-content').hide();
                $('.nav-batchdig-emails-content').hide();
                $('.nav-kp-dig-email-content').hide();
                $('.nav-company-search-staff-content').show();
            }
        }
    });
    //
}
nav_init();
//
$('#btn_linkedin-companies_add_batchdig_emails').click(function (){
    $('#message-info').html('<div class="alert-info">添加需要花费些时间，稍等...</div>');
    var bg = chrome.extension.getBackgroundPage();
    bg.linkedin_storage_companies_get(function (callback_data) {
        //
        let linkedin_companies = callback_data['linkedin_companies'];
        if (typeof linkedin_companies === 'undefined') {
            linkedin_companies = [];
        }
        //
        var export_linkedin_companies = [];
        for(i=0;i<linkedin_companies.length;i++){
               export_linkedin_companies.push({
                   'linkedin_company_link': linkedin_companies[i]['link'],
                   'name': linkedin_companies[i]['name'],
                   'company_website':linkedin_companies[i]['company_website'],
                   'industry':linkedin_companies[i]['industry'],
                   'guanzhuzhe':linkedin_companies[i]['guanzhuzhe'],
                   'description':linkedin_companies[i]['description']
               })
        }
        var domains = [];
        for(let f=0;f<linkedin_companies.length;f++){
            let _d = linkedin_companies[f]['company_website'];
            if(_d.indexOf('请') == -1 && _d.indexOf('无') == -1){
                var domain = {
                    'd':_d, //域名
                    'e':[], //邮箱列表
                    's':0,  //状态
                    'q':0,  //当前已请求量
                    'tq':0, //总请求量
                    't':0,  //当前请求完成时间戳
                    'm':0,   //长时间未动,popup->background主动更新
                }
                domains.push(domain);
            }
        }
        bg.domains_add(domains);
        //
        $('.batchdig-form').hide();
        $('#domains').val('');
        $('#message-info').html('<div class="alert-info">已成功添加'+domains.length+'个网站挖邮箱</div>');
        domains_process();
        //
    });
});

function extract_linkedin_companies_export(){
    $('#btn_linkedin-companies_export').click(function (){
        //
        $('#message-info').html('<span style="font-size: 12px;">导出需要花费时间，请保持界面不动,处理中...</span>');
        console.log('btn_linkedin-companies_export');
        //
        var bg = chrome.extension.getBackgroundPage();
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('extract_linkedin_companies_export');
            //console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if (typeof expire_date === 'undefined') {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            } else {
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z', '');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }
        });
        bg.linkedin_storage_companies_get(function (callback_data) {
            //
            let linkedin_companies = callback_data['linkedin_companies'];
            if (typeof linkedin_companies === 'undefined') {
                linkedin_companies = [];
            }
            //
            var export_linkedin_companies = [];
            for(i=0;i<linkedin_companies.length;i++){
               export_linkedin_companies.push({
                   'linkedin_company_link': linkedin_companies[i]['link'],
                   'name': linkedin_companies[i]['name'],
                   'company_website':linkedin_companies[i]['company_website'],
                   'industry':linkedin_companies[i]['industry'],
                   'guanzhuzhe':linkedin_companies[i]['guanzhuzhe'],
                   'description':linkedin_companies[i]['description']
               })
            }
            //
            exportToExcel(export_linkedin_companies, 'gycharm-linkedin_companies-export-'+Date.now(), "Sheet1");
            //
            //
            $('#message-info').html('');
        });
        //
    });
}

extract_linkedin_companies_export();

$('#btn_linkedin-companies_clean').click(function (){
    if(confirm("确定清空吗？注意清空需要花费些时间") == true){
        var bg = chrome.extension.getBackgroundPage();
        bg.linkedin_companies_clear();
    }
});

function linkedin_companies_process(){
    //console.log('linkedin_companies_process a1');
    //$('#message-info').html('加载中...');
    var bg = chrome.extension.getBackgroundPage();
    //
    bg.linkedin_storage_companies_get_data_process();
    //
    bg.linkedin_storage_companies_get(function (callback_data) {
        //console.log('linkedin_companies_process a2');
        //$('#message-info').html('');
        //
        linkedin_companies = callback_data['linkedin_companies'];
        //console.log(linkedin_companies);
        if(typeof linkedin_companies === 'undefined' ){
            linkedin_companies = [];
        }
        //
        var linkedin_companies_total = linkedin_companies.length;
        var linkedin_companies_has = 0;
        for(i=0;i<linkedin_companies.length;i++){
            if(linkedin_companies[i]['s'] == 2){
                linkedin_companies_has +=1;
            }
        }
        if(linkedin_companies_total>0){
            var domains_percentage = util_toDecimal(linkedin_companies_has/linkedin_companies_total)+'%';
        }else{
            var domains_percentage = '0.00%';
        }
        //
        if(linkedin_companies_total>0){
            var linkedin_compaies_summary = "已添加<span>"+linkedin_companies_total+"</span>个公司，已挖掘<span>"+linkedin_companies_has+"</span>个，进度<span>"+domains_percentage+"</span>";
            $('#linkedin-compaies-summary').html(linkedin_compaies_summary);
        }else{
            var linkedin_compaies_summary = "已添加<span>0</span>个公司，已挖掘<span>0</span>个，进度<span>0</span>";
            $('#linkedin-compaies-summary').html(linkedin_compaies_summary);
        }
        //
        if(linkedin_companies.length > 0){
            //
            $('.linkedin-companies-list-box').html('');

            for(i=0;i<linkedin_companies.length;i++){
                var _linkedin_company = linkedin_companies[i];
                let _linkedin_company_s = '等待爬取';
                if(_linkedin_company['s'] == 1){
                    _linkedin_company_s = '爬取中';
                }else if(_linkedin_company['s'] == 2){
                    _linkedin_company_s = '完成';
                }
                var bl_item_html = "<div class='bl-item'>";
                bl_item_html += "<div class='bl-item-name'><a href='"+_linkedin_company['link']+"' target='_blank'>"+_linkedin_company['name']+"</a></div>";
                bl_item_html += "<div class='bl-item-s'>"+_linkedin_company_s+"</div>";
                if(_linkedin_company['company_website'].indexOf('请') != -1){
                    bl_item_html += "<div class='bl-item-company_website'>"+_linkedin_company['company_website']+"</div>";
                }else{
                    bl_item_html += "<div class='bl-item-company_website'><a href='"+_linkedin_company['company_website']+"' target='_blank'>"+_linkedin_company['company_website']+"</a></div>";
                }


                bl_item_html += "</div>";
                //
                $('.linkedin-companies-list-box').append(bl_item_html);
                //
            }
            //
        }else{
             $('.linkedin-companies-list-box').html('');
        }
    });
}
linkedin_companies_process();

setInterval(linkedin_companies_process, 3000);

function linkedin_pause(){
    $('#linkedin-pause').click(function (){
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_switch(function (){
            bg.storage_get(function (callback_data) {
                if(callback_data.hasOwnProperty('pause') && callback_data['pause'] == 1){
                    $('#linkedin-pause').text('采集已暂停,可点击开启');
                }else{
                    $('#linkedin-pause').text('采集已开启,可点击暂停');
                }
            });
          //
        });
        //
    });
}
linkedin_pause();

//linkedin people
function extract_linkedin_people_export(){
    $('#btn_linkedin-people_export').click(function (){
        //
        $('#message-info').html('<span style="font-size: 12px;">导出需要花费时间，请保持界面不动,处理中...</span>');
        //console.log('btn_linkedin-people_export');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            //console.log('extract_linkedin_companies_export');
            //console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if (typeof expire_date === 'undefined') {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            } else {
                //console.log('expire_date');
                //console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z', '');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }
        });
        //
        chrome.storage.local.get(null, function(items) {
            //
            var export_linkedin_peoples = [];
            for(key in items){
                if(key.indexOf('linkedin_people_')!=-1){
                     export_linkedin_peoples.push({
                        'people_url': items[key]['_people_url'],
                        'people_name': items[key]['_people_name'],
                        'people_img': items[key]['_people_img'],
                        'people_conn': items[key]['_people_du'],
                        'people_position': items[key]['_people_position'],
                        'people_country': items[key]['_people_country'],
                        'people_summary': items[key]['_people_summary'],
                        '_people_sales_url':items[key]['_people_sales_url'],
                        '_poeple_mutual_connections':items[key]['_poeple_mutual_connections'],
                        'is_request': items[key]['_is_request'] == 2?'已完成':'未',
                    });
                }
            }
            //
            exportToExcel(export_linkedin_peoples, 'gycharm-linkedin-peoples-export-'+Date.now(), "Sheet1");
            //
        });
        //
    });
}
extract_linkedin_people_export();

//
function linkedin_people_process(){
    //console.log('linkedin_people_process a1');
    chrome.storage.local.get(null, function(items) {
        //
        let _total = 0;
        let _has_total = 0;
        let _percentage = '0.00%';
        for(key in items){
            if(key.indexOf('linkedin_people_') !=-1){
                _total += 1;
                if(items[key]['_is_request'] == 2){
                    _has_total += 1;
                }
            }
        }
        if(_total>0){
            _percentage = util_toDecimal(_has_total/_total)+'%';
        }
        //
        if(_total>0){
            let linkedin_people_summary = "已添加<span>"+_total+"</span>个人员，已挖掘<span>"+_has_total+"</span>个，进度<span>"+_percentage+"</span>";
            $('#linkedin-people-summary').html(linkedin_people_summary);
        }else{
            var linkedin_people_summary = "已添加<span>0</span>个人员，已挖掘<span>0</span>个，进度<span>0</span>";
            $('#linkedin-people-summary').html(linkedin_people_summary);
        }
        //
    });
}
linkedin_people_process();
setInterval(linkedin_people_process, 3000);
//
$('#btn_linkedin-people_clean').click(function (){
    if(confirm("确定清空吗？注意清空需要花费些时间") == true){
        var bg = chrome.extension.getBackgroundPage();
        bg.linkedin_people_clear();
    }
});
//end

//linkedin kp
function linkedin_kp_process(){
    //console.log('linkedin_kp_process a1');
    $('#message-info').html('加载中...');
    //
    chrome.storage.local.get(null, function(items) {
        //
        let _linkedin_kp_add_form = '<form><div style="display: flex;justify-content: flex-start;flex-wrap: wrap;">';
        let linkedin_kp_datas = [];
        for(key in items) {
            //console.log(key);
            if (key.indexOf('linkedin_kp_') != -1) {
                linkedin_kp_datas.push(items[key]);
            }
        }
        //
        let linkedin_kp_datas_new = util_dictArraySorting(linkedin_kp_datas, '_num', 'asc');
        //
        for(key in linkedin_kp_datas_new){
            //
            let _linkedin_kp_data = linkedin_kp_datas_new[key];
            let _company_url = _linkedin_kp_data['_company_url'];
            if(typeof _company_url == 'undefined'){
                _company_url = '';
            }
            let _linkedin_kp_item_html = "<div class='_linkedin_kp_item'>";
            _linkedin_kp_item_html += "<div class='_img'><a href='"+_linkedin_kp_data['_linkedin_url']+"' target='_blank'><img src='"+_linkedin_kp_data['_img']+"' style='width: 50px;'/></a><div class='_btn_del' _linkedin_id='"+_linkedin_kp_data['id']+"'><span>×</span></div></div>";
            _linkedin_kp_item_html += "<div class='_name'>"+_linkedin_kp_data['_name']+"</div>";
            _linkedin_kp_item_html += "<div class='_company_url'><input _linkedin_id='"+_linkedin_kp_data['id']+"' name='_company_url' class='_company_url_input' value='"+_company_url+"' placeholder='输入域名' /></div>";
            _linkedin_kp_item_html += "<div class='_position'>"+_linkedin_kp_data['_position']+"</div>";
            _linkedin_kp_item_html +="</div>";
            //
            _linkedin_kp_add_form +=_linkedin_kp_item_html;
        }
        _linkedin_kp_add_form +='</div></form>';
        let _linkedin_kp_add_form_jquery = $(_linkedin_kp_add_form)
        _linkedin_kp_add_form_jquery.find('._btn_del').click(function (){
            let _linkedin_id =  $(this).attr('_linkedin_id');
            linkedin_kp_delete(_linkedin_id);
        });
        _linkedin_kp_add_form_jquery.find('._company_url_input').on('blur',function (){
            let _linkedin_id =  $(this).attr('_linkedin_id');
            let _company_url =  $(this).val();
            _company_url = _company_url.trim();
            linkedin_kp_company_url_update(_linkedin_id, _company_url);
        }).on('focus',function (){
            $(this).css({'border':'1px solid #000'});
        });
        $('.linkedin-kp-list-box').html(_linkedin_kp_add_form_jquery);
        $('#message-info').html('');
        //
    });
}
linkedin_kp_process();
//setInterval(linkedin_kp_process, 10000);

function linkedin_kp_delete(_linkedin_id){
   //var bg = chrome.extension.getBackgroundPage();
   //bg.linkedin_storage_kp_delete(_linkedin_id);
   //linkedin_kp_process();
   $('#message-info').html('<div className="alert-info">处理中...</div>');
   let prefix = 'linkedin_kp_'+$.md5(_linkedin_id);
   chrome.storage.local.get(null, function(items) {
       //
         if (items.hasOwnProperty(prefix)) {
             chrome.storage.local.remove([prefix],function(){
                var error = chrome.runtime.lastError;
                if (error){
                    $('#message-info').html('<span style="color:red;">删除失败!</span>');
                }
                else{
                    $('#message-info').html('<div className="alert-info">删除成功</div>');
                }
                //
                 linkedin_kp_process();
                 //
             })
         }
   });
}

function linkedin_kp_company_url_update(_linkedin_id, _company_url){
    //
    $('#message-info').html('<div className="alert-info">处理中...</div>');
    if(_company_url){
        _company_url = _company_url.replace('https','').replace('http','').replace('://','').replace('www.','');
        _company_url_arr = _company_url.split('/');
        _company_url = _company_url_arr[0];
        //
        let prefix = 'linkedin_kp_'+$.md5(_linkedin_id);
        //
        chrome.storage.local.get(null, function(items) {
            //
            if(items.hasOwnProperty(prefix)){
                let linkedin_kp_data = items[prefix];
                let obj = {};
                obj[prefix] = {
                    'id': linkedin_kp_data['id'],
                    '_name': linkedin_kp_data['_name'],
                    '_img': linkedin_kp_data['_img'],
                    '_linkedin_url': linkedin_kp_data['_linkedin_url'],
                    '_position': linkedin_kp_data['_position'],
                    '_company_name': linkedin_kp_data['_company_name'],
                    '_company_url': _company_url,
                    '_num':linkedin_kp_data['_num'],
                    'is_request':0
                };
                chrome.storage.local.set(obj, function (){
                    $('#message-info').html('<div className="alert-info">更新成功</div>');
                });
            }
            //
        });
        //
    }
    //
}

function linkedin_kp_storage_clear(){
    $('#message-info').html('<div className="alert-info">处理中...</div>');
    chrome.storage.local.get(null, function(items) {
        let keys = [];
        for(key in items){
            if(key.indexOf('linkedin_kp_') !=-1){
                keys.push(key);
            }
        }
        chrome.storage.local.remove(keys,function(){
            var error = chrome.runtime.lastError;
            if (error){console.error(error);}
            else{
                //console.log('domains '+keys.join('-')+' has remove');
                $('#message-info').html('<div className="alert-info">清空完成</div>');
                linkedin_kp_process();
            }
        })
    })
}
$('#btn_linkedin-kp_clean').click(function (){
    linkedin_kp_storage_clear();
})

function btn_linkedin_kp_add_batchdig_emails(){
    $('#btn_linkedin-kp_add_batchdig_emails').click(function (){
        ////
        var bg = chrome.extension.getBackgroundPage();
        bg.plugin_get_expire(function (callback_data) {
            let expire_date = callback_data['expire'];
            if (typeof expire_date === 'undefined') {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            } else {
                expire_date = expire_date.replace('T00:00:00.000Z', '');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }
        })
        ////
        $('#message-info').html('<div class="alert-info">处理中...</div>');
        let validate = true;
        let _task_name = $('#_task_name').val();
        _task_name = _task_name.trim();
        if(_task_name == ''){
            $('#_task_name').css({'border':'1px solid red'});
            validate = false;
        }
        $('._company_url_input').each(function (){
           let _company_url_val = $(this).val();
           _company_url_val = _company_url_val.trim();
           if(_company_url_val == ''){
               $(this).css({'border':'1px solid red'});
               validate = false;
           }else if(_company_url_val.indexOf('.') == -1){
               $(this).css({'border':'1px solid red'});
               validate = false;
           }
        });
        //
        if(validate){
            //
            chrome.storage.local.get(null, function(items) {
                let linkedin_kp_datas = [];
                for(key in items) {
                    if (key.indexOf('linkedin_kp_') != -1) {
                        linkedin_kp_datas.push(items[key]);
                    }
                }
                if(linkedin_kp_datas.length > 0){
                    let task_create_data = {
                        'name': _task_name,
                        'linkedin_name_domain': linkedin_kp_datas,
                        'active_code':items['active_code']
                    }
                    console.log('task_create_data');
                    console.log(task_create_data);
                    ////
                    // other then GET
                    let options = {
                        method: 'POST',
                        headers: {
                            'Content-Type':'application/json;charset=utf-8'
                        },
                        body: JSON.stringify(task_create_data)
                        //body: task_create_data
                    }
                    // Fake api for making post requests
                    let fetchRes = fetch( "https://api.gycharm.com/v1/linkedinnew", options);
                    fetchRes.then(res =>
                        res.json()).then(d => {
                            console.log('post response:');
                            console.log(d);
                            if(d['status']){
                                linkedin_kp_storage_clear();
                                $('#message-info').html('<div class="alert-info">加入成功！</div>');
                            }else{
                                $('#message-info').html('<div style="color:red;">'+d['message']+'</div>');
                            }
                        })
                    ////
                }else{
                    $('#message-info').html('<div style="color:red;">请先添加人员!</div>');
                }
            });
            //
        }
        //
    });
    $('#_task_name').focus(function (){
        $(this).css({'border':'1px solid #000'});
    });

}
btn_linkedin_kp_add_batchdig_emails();
//end

function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}
